/* Drip - a transcoder for Unix
 * Copyright (C) 2001-2003 Jarl van Katwijk
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gnome.h>
#include <dirent.h>

extern GtkWidget *spinbutton1;
extern GtkWidget *spinbutton2;
extern GtkWidget *spinbutton3;
extern GtkWidget *spinbutton4;
extern GtkWidget *spinbutton5;
extern GtkWidget *entry3;
extern GtkWidget *druid_vbox3;
extern GtkWidget *druid_vbox2;
extern GtkWidget *window1;
extern GtkWidget *hbox21;
extern GtkWidget *hbox22;
extern GtkWidget *vbox9b;
extern GtkWidget *frame1;
extern GtkWidget *frame5;
extern GtkWidget *select_dialog;
extern GtkWidget *audio_subpicture_dialog;
extern GtkWidget *combo_entry12;
extern GtkWidget *label_filter_type;
extern GtkWidget *label_filter_phase;
extern GtkWidget *hbox35;


/* proto's */
void on_checkbutton_advanced_toggled(GtkToggleButton *togglebutton, gpointer user_data);

void on_combo_avi_entry_changed(GtkEditable *editable, gpointer user_data);

gint build_compare(gconstpointer a,gconstpointer b);

gint dvdtree_add_chapter(gint VTS,gint VT,gint PC,gint CHAP,gint CHAP_TOTAL,gint ANGL);
gint dvdtree_delete_chapter(gint VTS,gint VT,gint PC,gint CHAP,gint CHAP_TOTAL,gint ANGL);

void build_compose_avilist();

void g_list_move_up(GList *list,gint position);
void g_list_move_down(GList *list,gint position);

void bind_titles_guitype(void);

void
on_ripdvd_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_dvd2vcd_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_rescan_for_dvd_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save_preferences_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_stop_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_pause_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_button_main_rip_clicked             (GtkButton       *button,
                                        gpointer         user_data);

void
on_button_main_dvd2vcd_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_button_main_rescan_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_button_up_clicked                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button_down_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void
on_dvdtitels_select_row               (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void
on_dvdtitels_unselect_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_button_eject_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton_honor_aspect_toggled    (GtkToggleButton *button,
                                        gpointer         user_data);

void
on_checkbutton_debug_toggled           (GtkToggleButton *button,
                                        gpointer         user_data);

void
on_checkbutton_hyperzoom_toggled       (GtkToggleButton *button,
                                        gpointer         user_data);

void
on_checkbutton_autoclip_toggled        (GtkToggleButton *button,
                                        gpointer         user_data);

void
on_checkbutton_deinterlace_toggled     (GtkToggleButton *button,
                                        gpointer         user_data);

void
on_checkbutton_pulldown_toggled        (GtkToggleButton *button,
                                        gpointer         user_data);

void
on_button_main_pref_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_homepage_activate                   (GtkButton       *button,
                                        gpointer         user_data);

void
on_button_main_exit_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_propertybox1_destroy                (GtkObject       *object,
                                        gpointer         user_data);

gboolean
on_mainwindow_destroy_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_combo_entry_dvddevice_changed       (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry_plugin_changed          (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry_dvdsource_changed       (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry2_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_blur_changed             (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_cpus_changed             (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_video_bitrate_changed    (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_homepagebutton_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_spinbutton_video_stream_changed     (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_audio_bitrate_changed         (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_audio_stream_changed     (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_radiobutton_divx_codecfast_toggled  (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_PAL_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_NTSC_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_divx_codeclow_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_divx_opendivx_toggled   (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_spinbutton_clip_changed             (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_clipleft_changed         (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_clipright_changed        (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_clip_offset_changed      (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_clipframes_changed      (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_entry_divx_blurradius_changed       (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_checkbutton_limit_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_checkbutton_eject_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_checkbutton_active_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_checkbutton_dvddb_toggled           (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_entry2_changed                      (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_checkbutton_audionorm_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_spinbutton_width_changed            (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_heigth_changed           (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_spinbutton_angle_changed           (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_button_calculate_bitrate_clicked    (GtkButton       *button,
                                        gpointer         user_data);


void
on_dvdstreams_select_row               (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void
on_dvdstream_ok_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_dvdstream_cancel_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton_HD_cache_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_checkbutton_encode_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_spinbutton_maxsizeoutput_changed    (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_radiobutton_useDVDdevice_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_useDVDsource_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_button_ok_stop_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_button_no_stop_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_combo_entry_cache_location_changed  (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_checkbutton_delete_cache_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void
on_checkbutton_chunk_cache_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_checkbutton_iso_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data);

void
on_radiobutton_audio_1st_channel_0_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_1st_channel_1_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_1st_channel_2_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_1st_channel_3_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_1st_channel_4_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_1st_channel_5_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_1st_channel_6_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_1st_channel_7_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_2nd_channel_0_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_2nd_channel_1_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_2nd_channel_2_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_2nd_channel_3_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_2nd_channel_4_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_2nd_channel_5_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_2nd_channel_6_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_radiobutton_audio_2nd_channel_7_toggled (GtkToggleButton *togglebutton,
                                        gpointer         user_data);


void
on_combo_entry9_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry11_changed               (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_audiocodec_changed            (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_combo_entry_DVDtitle_changed        (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_drip_druid_cancel                   (GnomeDruid      *gnomedruid,
                                        gpointer         user_data);

gboolean
on_drip_druid_next                     (GnomeDruidPage *druidpage,
                                        gpointer arg1,
                                        gpointer user_data);

gboolean
on_drip_druid_next_cache               (GnomeDruidPage *druidpage,
                                        gpointer arg1,
                                        gpointer user_data);

void
on_drip_druidpagefinish1_finish        (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_mainwindow_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void on_reset_to_default_clicked(GtkButton *button,gpointer user_data);

void
on_button20_clicked                    (GtkButton       *button,
                                        gpointer         user_data);
void
on_button21_clicked                    (GtkButton       *button,
                                        gpointer         user_data);
void
on_button22_clicked                    (GtkButton       *button,
                                        gpointer         user_data);
void
on_button23_clicked                    (GtkButton       *button,
                                        gpointer         user_data);


void
on_combo_audio_preferenceA_changed            (GtkEditable     *editable,
                                        gpointer         user_data);
void
on_combo_audio_preferenceB_changed            (GtkEditable     *editable,
                                        gpointer         user_data);
void
on_combo_spu_preferenceA_changed            (GtkEditable     *editable,
                                        gpointer         user_data);
void
on_combo_spu_preferenceB_changed            (GtkEditable     *editable,
                                        gpointer         user_data);

void on_checkbutton_2nd_audio_toggled(GtkToggleButton *togglebutton, gpointer user_data);

void dvdtree_select_itemsignal(GtkWidget *item,GtkTreeItem *treeitem);
void dvdtree_deselect_itemsignal(GtkWidget *item,GtkTreeItem *treeitem);
void dvdtree_unselect_child(GtkWidget *root_tree,GtkWidget *child,GtkWidget *subtree);
void dvdtree_select_child(GtkWidget *root_tree,GtkWidget *child,GtkWidget *subtree);
void dvdtree_selection_changed(GtkWidget *tree);

